package org.jcz.persistence;

import java.util.ArrayList;
import java.util.Collection;

import org.apache.log4j.Logger;

public aspect PaginationSupportAspect extends ServiceSupportAspect {
	private static final Logger log = Logger.getLogger(PaginationSupportAspect.class);

	private pointcut paginate(Criteria criteria) :
		call(Collection org.jcz.persistence.Service+.*(Criteria)) && args(criteria);

	@SuppressWarnings({ "unchecked", "rawtypes" })
	Collection around(Criteria criteria, Service service) : paginate(criteria) && target(service) {
		log.trace(String.format("Executing <%s> @ <%s>", this.getClass(), thisJoinPoint.toLongString()));
		return doPaginate(proceed(criteria, service), criteria.getPagination(), service);
	}

	private <T extends EntitySupport> Collection<T> doPaginate(
			Collection<T> source, Pagination pagination, Service<T> service)
	{
		System.out.println("doPaginate");
		return new ArrayList<T>();
	}
}